Mail::Box::Locker::POSIX(3pm)

NAME
Mail::Box::Locker::POSIX - lock a folder using kernel file-locking

INHERITANCE
 Mail::Box::Locker::POSIX
   is a Mail::Box::Locker
   is a Mail::Reporter

SYNOPSIS
  See Mail::Box::Locker

DESCRIPTION
This locker object is created by the folder to get an exclusive lock on the file which contains the data using the kernel's POSIX facilities. This lock is created on a separate file-handle to the folder file, so not the handle which is reading.

WARNING: Not all platforms support POSIX locking (via fcntl) and not always in the same way. This implementation does not use XS to access the structure of fcntl(): it is better to use the ::FcntlLock which does. No, this implementation "guesses" the location of the bytes.

Extends "DESCRIPTION" in Mail::Box::Locker.

METHODS
Extends "METHODS" in Mail::Box::Locker.

  Constructors
Extends "Constructors" in Mail::Box::Locker.

$class->new(%options)
    Inherited, see "METHODS" in Mail::Box::Locker

     -Option    --Defined in       --Default
      expires     Mail::Box::Locker  1 hour
      file        Mail::Box::Locker  undef
      folder      Mail::Box::Locker  <C<undef>>
      method      Mail::Box::Locker  POSIX
      posix_file                     <C<undef>>
      timeout     Mail::Box::Locker  10

    expires => $seconds
    file => $file
    folder => $folder
    method => $name|CLASS|\@names
    posix_file => FILENAME
        Alternative name for "file", especially useful to avoid confusion when the multi-locker is used.

    timeout => $seconds|'NOTIMEOUT'

  Attributes
Extends "Attributes" in Mail::Box::Locker.

$obj->expires( [SECONDS] )
    Inherited, see "Attributes" in Mail::Box::Locker

$obj->filename( [$filename] )
    Inherited, see "Attributes" in Mail::Box::Locker

$obj->folder( [$folder] )
    Inherited, see "Attributes" in Mail::Box::Locker

$obj->name()
    Inherited, see "Attributes" in Mail::Box::Locker

$obj->timeout( [SECONDS] )
    Inherited, see "Attributes" in Mail::Box::Locker

  Locking
Extends "Locking" in Mail::Box::Locker.

$obj->hasLock()
    Inherited, see "Locking" in Mail::Box::Locker

$obj->isLocked()
    Inherited, see "Locking" in Mail::Box::Locker

$obj->lock()
    Inherited, see "Locking" in Mail::Box::Locker

$obj->unlock()
    Inherited, see "Locking" in Mail::Box::Locker

  Error handling
Extends "Error handling" in Mail::Box::Locker.

$obj->AUTOLOAD()
    Inherited, see "Error handling" in Mail::Reporter

$obj->notImplemented()
    Inherited, see "Error handling" in Mail::Reporter

  Cleanup
Extends "Cleanup" in Mail::Box::Locker.

$obj->DESTROY()
    Inherited, see "Cleanup" in Mail::Box::Locker

DIAGNOSTICS

Error: class $package does not implement method $method.
    Fatal error: the specific $package (or one of its superclasses) does not implement this method where it should. This message means that some other related classes do implement this method however the class at hand does not. Probably you should investigate this and probably inform the author of the package. Cast by notImplemented()

Warning: folder $name already lockf'd.
    Cast by lock()

Fault: unable to check lock file $file for $folder: $!
    To check whether the $file is used to flock a $folder, the file must be opened. Apparently this fails, which does not mean that the folder is locked neither that it is unlocked. Cast by isLocked()

Fault: unable to open POSIX lock file $file for $folder: $!
    For POSIX style locking, a $folder it must be opened, which does not succeed for the specified reason. Cast by lock()

Fault: will never get a POSIX lock at $file for $folder: $!
    Tried to lock the $folder, but it did not succeed. The error code received from the OS indicates that it will not succeed ever, so we do not need to try again. Cast by lock()

SEE ALSO
This module is part of Mail-Box version 4.01, built on December 13, 2025. Website: http://perl.overmeer.net/CPAN/

LICENSE
For contributors see file ChangeLog.

This software is copyright (c) 2001-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.